//Helpful Functions/Methods
autolocal(1);

include("system.prg");

function abs(int)
{
	if(int < 0)
	{
		int = -1 * int;
	}
	return int;
}

function waitUpTo(seconds)
{
	clearBuffer();
	local(startTickCount) = getTickCount();
	local(stop) = 1;
	while(stop == 1)
	{
		local(ke) = get();
		if(((((getTickCount() - startTickCount)%60000))/1000) >= seconds)
		{
			kill(stop);
		}
		elseif(ke ~= "" && ke ~= "LEFT" && ke ~= "RIGHT" && ke ~= "UP" && ke ~= "DOWN")
		{
			kill(stop);
		}
	}
}

function setLight(red, green, blue)
{
	setAmbientLevel(red, green, blue);
//	newPlayer("graySplit.tem");
	addPlayer("select.tem");
	putPlayer(playerHandle[1], playerx[0] + 1, playery[0] + 1, playerlayer[0]);
	destroyPlayer(playerHandle[1]);
	newPlayer("graySplit.tem");
}

//Flash-indicate a tile
function indicate(xx, yy, zz)
{
	addPlayer("select.tem");
	putPlayer(playerHandle[1], xx, yy, zz);
	playerStance(playerHandle[1], "Confirm");
	clearBuffer();
	while(get() == "")
	{
		playerStance(playerHandle[1], "Confirm");
	}
	destroyPlayer(playerHandle[1]);
}

//Check to see if thread exists
function threadExists(thread)
{
	setErrorHandler(:error);
	threadSleepRemaining(thread);
	return true;

:error
	return false;
}

//Pick an index for thread to use
function pickIndex()
{
	for(index = 1; index < 50; index++)
	{
		if(threadExists(threadn[index]))
		{
		}
		else
		{
		return index
		index = 49
		}
	}
}

//Combine the above two for easy setup
function threadSetup();
{
	index = pickIndex();
	global(threadCheck[index]) = 1;
	global(threadn[index]) = getThreadId();
	return index;
}

//Wait a specified amount of time before continuing
function waitTime(seconds)
{
	thread = thread("blank.prg", 0);
	threadSleep(thread, seconds);
	while(threadSleepRemaining(thread) ~= 0)
	{
	}
	killThread(thread);
	kill(thread);
}

//Check for item's existence
function itemExists(x, y, l);
{
	debug(0);
	for(index = 0; index < 100; index++)
	{
		itemlocation(index, ix, iy, il);
		setResumeNextHandler();
		if(ix == x && iy == y && il == l)
		{
			debug(1);
			return index;
		}
		setResumeNextHandler();
	}
	return -1;
}

//Assign all hotkeys blank values
function hotkeyCls();
{
	global(fprg) = "blank.prg";
	global(gprg) = "blank.prg";
	global(hprg) = "blank.prg";
	global(jprg) = "blank.prg";
	global(kprg) = "blank.prg";
	global(tprg) = "blank.prg";
	global(yprg) = "blank.prg";
	global(vprg) = "blank.prg";
	global(bprg) = "blank.prg";
	global(nprg) = "blank.prg";
	global(mprg) = "menu.prg";
	global(enterprg) = "blank.prg";
	global(spaceprg) = "blank.prg";
}

//Draw black screen with words
function wordCanvas(string, seconds)
{
	fade(5);
	fade(0);
	getcolor(ir, ig, ib);
	colorRgb(1, 1, 1);
	canv = createCanvas(640, 480);
	fillRect(0, 0, 640, 480, canv);
	colorRgb(ir, ig, ib);
	height = getTextHeight(string);
	top = (480 - height)/2
	width = getTextWidth(string);
	left = (640 - width)/2
	pixelText(left, top, string, canv);
	drawCanvas(canv, 0, 0);
	delay(seconds);
	wait();
}

//Empty globals except a select few
function emptySave(string)
{
	tempGS = gamestate;
	tempName = name;
	//etc
	empty();
	global(gamestate) = tempGS;
	global(name) = tempName;
	//etc
}

//Null a solid vector
function nullVector(vector)
{
	boardGetVector(castNum(vector), type, pointCount, layer, isClosed, attributes);
	boardSetVector(castNum(vector), tkVT_WAYPOINT, pointCount, layer, isClosed, attributes);
}

//Solidify a nulled vector
function solidifyVector(vector)
{
	boardGetVector(castNum(vector), type, pointCount, layer, isClosed, attributes);
	boardSetVector(castNum(vector), tkVT_SOLID, pointCount, layer, isClosed, attributes);
}

//Find a vector at a given set of coordinates and return its handle
//This is complicated so I am not even going to attempt to annotate or explain it
function vectorExists(x, y, l)
{
	leftx = ((32 * x) - 32);
	rightx = (32 * x);
	topy = ((32 * y) - 32);
	bottomy = (32 * y);
	vectorCount = boardGetVector();
	for(index = 0; index < vectorCount; index++)
	{
		boardGetVector(index, type, pointCount, layer, isClosed, attributes);
		if(pointCount == 4 && layer == l)
		{
			boardGetVectorPoint(index, 0, x[0], y[0])
			boardGetVectorPoint(index, 1, x[1], y[1])
			boardGetVectorPoint(index, 2, x[2], y[2])
			boardGetVectorPoint(index, 3, x[3], y[3])
			if(x[0] == x[1])
			{
				if(x[0] == leftx || x[0] == rightx)
				{
					if(x[2] == leftx || x[2] == rightx)
					{
						branch(:branch);
					}
				}
			}
			elseif(x[0] == x[2])
			{
				if(x[0] == leftx || x[0] == rightx)
				{
					if(x[3] == leftx || x[3] == rightx)
					{
						branch(:branch);
					}
				}
			}
			elseif(x[0] == x[3])
			{
				if(x[0] == leftx || x[0] == rightx)
				{
					if(x[1] == leftx || x[1] == rightx)
					{
						branch(:branch);
					}
				}
			}
			if(proceed == 1)
			{
:branch
				if(y[0] == y[1])
				{
					if(y[0] == topy || y[0] == bottomy)
					{
						if(y[2] == topy || y[2] == bottomy)
						{
							return index;
						}
					}
				}
				elseif(y[0] == y[2])
				{
					if(y[0] == topy || y[0] == bottomy)
					{
						if(y[3] == topy || y[3] == bottomy)
						{
							return index;
						}
					}
				}
				elseif(y[0] == y[3])
				{
					if(y[0] == topy || y[0] == bottomy)
					{
						if(y[1] == topy || y[1] == bottomy)
						{
							return index;
						}
					}
				}
			}
		}
	}
//	debugger("Vector not found");
	return -1;
}

function programExists(x, y, l)
{
	leftx = ((32 * x) - 32);
	rightx = (32 * x);
	topy = ((32 * y) - 32);
	bottomy = (32 * y);
	programCount = boardGetProgram();
	for(index = 0; index < programCount; index++)
	{
		boardGetProgram(index, type, pointCount, layer, isClosed, attributes);
		if(pointCount == 4 && layer == l)
		{
			boardGetProgramPoint(index, 0, x[0], y[0])
			boardGetProgramPoint(index, 1, x[1], y[1])
			boardGetProgramPoint(index, 2, x[2], y[2])
			boardGetProgramPoint(index, 3, x[3], y[3])
			if(x[0] == x[1])
			{
				if(x[0] == leftx || x[0] == rightx)
				{
					if(x[2] == leftx || x[2] == rightx)
					{
						branch(:nxtprgalg);
					}
				}
			}
			elseif(x[0] == x[2])
			{
				if(x[0] == leftx || x[0] == rightx)
				{
					if(x[3] == leftx || x[3] == rightx)
					{
						branch(:nxtprgalg);
					}
				}
			}
			elseif(x[0] == x[3])
			{
				if(x[0] == leftx || x[0] == rightx)
				{
					if(x[1] == leftx || x[1] == rightx)
					{
						branch(:nxtprgalg);
					}
				}
			}
			if(proceed == 1)
			{
:nxtprgalg
				if(y[0] == y[1])
				{
					if(y[0] == topy || y[0] == bottomy)
					{
						if(y[2] == topy || y[2] == bottomy)
						{
							return index;
						}
					}
				}
				elseif(y[0] == y[2])
				{
					if(y[0] == topy || y[0] == bottomy)
					{
						if(y[3] == topy || y[3] == bottomy)
						{
							return index;
						}
					}
				}
				elseif(y[0] == y[3])
				{
					if(y[0] == topy || y[0] == bottomy)
					{
						if(y[1] == topy || y[1] == bottomy)
						{
							return index;
						}
					}
				}
			}
		}
	}
//	debugger("Vector not found");
	return -1;
}

function fadeMedia()
{
	for(volume = 100; volume > 0; volume--)
	{
		setVolume(volume);
		delay(.05);
	}
	mediaStop();
	setVolume(100);
}

//Checks if item is in inventory
function itemInInventory(string)
{
	kill(index);
	kill(count);
	for(index = 0; index < 15; index++)
	{
		if(item[index] == string)
		{
			local(count)++;
		}
	}
	return local(count);
}

//Add item to inventory
function itemAdd(string)
{
	for(index = 0; index < 12; index++)
	{
		if(item[index] == "")
		{
			global(item[index]) = string;
			branch(:added);
		}
	}
	if(string == "logs")
	{
		for(index = 12; index < 15; index++)
		{
			if(item[index] == "")
			{
				global(item[index]) = string;
				branch(:added);
			}
		}
	}
	else
	{
		says("", "Your inventory is full. You cannot hold any more items.");
	}
:added
	get(); //<--filler
}

//Express excitement over getting an item
function yay(string)
{
//	wav("item1-cut.mp3");
	says("", "You got " + string + "!");
}

//Remove item from inventory
function itemRemove(string)
{
	for(index = 0; index < 15; index++)
	{
		if(item[index] == string)
		{
			kill(item[index]);
			for(index = index; index < 16; index ++)
			{
				global(item[index]) = item[index + 1];
			}
			index = 16;
		}
	}
}

function ingredient(crystal, number)
{
	split(crystal, ",", ing[]);
	return ing[number];
}

//Find out if prescribed location is nearby, mainly for item usage
//   1 1 1
//   1 P 1
//   1 1 1
function locationNearby(x, y, l)
{
	px = playerx[0];
	py = playery[0];
	pl = playerLayer[0];
	for(int = -1; int < 2; int++)
	{
		checky = py + int;
		for(integ = -1; integ < 2; integ++)
		{
			checkx = px + integ;
			if(checkx == x && checky == y && pl == l)
			{
				return 1;
			}
		}
	}
	return 0;
}

//Find out if prescribed location is orthogonally nearby, mainly for treasure chests
//   0 1 0
//   1 P 1
//   0 1 0
function locationNearbyOrth(x, y, l)
{
	px = playerx[0];
	py = playery[0];
	pl = playerLayer[0];
	for(int = -1; int < 2; int++)
	{
		checky = py + int;
		for(integ = -1; integ < 2; integ++)
		{
			checkx = px + integ;
			if(checkx == x && checky == y && pl == l)
			{
				if(abs(int + integ) == 1)
				{
					return 1;
				}
			}
		}
	}
	return 0;
}

//Boolean looking at given location
function lookingAt(x, y, l);
{
	px = playerx[0];
	py = playery[0];
	pl = playerLayer[0];
	global(dx) = px;
	global(dy) = py;
	dir = playerDirection(playerHandle[0]);
	if(dir == 1)
	{
		dx++;
	}
	elseif(dir == 3)
	{
		dy++;
	}
	elseif(dir == 5)
	{
		dx--;
	}
	elseif(dir == 7)
	{
		dy--;
	}
	if(dx == x && dy == y && pl == l)
	{
		return 1;
	}
	else
	{
		return 0;
	}
}

function lookingWhere(&x, &y, &l)
{
	x = playerx[0];
	y = playery[0];
	l = playerLayer[0];
	dir = playerDirection(playerHandle[0]);
	if(dir == 1)
	{
		x++;
	}
	elseif(dir == 3)
	{
		y++;
	}
	elseif(dir == 5)
	{
		x--;
	}
	elseif(dir == 7)
	{
		y--;
	}
}

//Wrap text
function wrapText(string, x, y, len, canvas)
{
	ratio = 10.5/64;
	charMax = (len * ratio);
	charMax = castInt(charMax);
	//debugger("charMax = " + charMax);
	str = string;
	strLen = len(str);
	strTemp = left(str, charMax);
	text(x, y, strTemp, canvas);
	str = right(str, strLen - charMax); // Chops off first 45 characters of string
	//debugger(str);
	strLen = strLen - charMax; // Reduces string length by amount chopped off
	for (strLen; strLen > 0; strLen++)
	{
		//debugger("in loop");
		line++;
		strTemp = left(str, charMax);
		str = right (str, strLen - charMax);
		//debugger(str);
		text(x, y + line, strTemp, canvas);
		strLen = strLen - charMax;
		strLen--;
	}
}

function jsend(board, x, y, z)
{
	if(gamestate >= 3 || (getBoardName() == "hepher.brd" && playerx[0] == 3 && gamestate == 2.5))
	{
		if(gamestate == 7)
		{
			send(board, x, y, z);
		}
		elseif(juirr + juirrColor > 1) //elseif(juirr > 1)
		{
			global(juirr) -= .5;
			if(juirr <= 1)
			{
				says("", "Your juirr level is getting low. You should refill at your nearest convenience.");
			}
			send(board, x, y, z);
		}
		elseif(juirr + juirrColor == 1) //elseif(juirr == 1)
		{
			if(juirrColor == 1)
			{
				says("", "You are out of juirr.");
				push(2);
			}
			else
			{
				says("", "It's too risky to access this portal with such a low juirr level. It would be in your best interest to go recharge.");
				push(2);
			}
		}
		elseif(juirr == 0 && juirrColor == "")
		{
			says("", "In your current state, your juirr level is at zero. You must refill your juirr level before you can continue to pathFind().");
			push(2);
		}
		else
		{
			debugger("Error with juirr level.");
		}
	}
	else
	{
		says("", "That's probably not your priority right now.");
		push(2);
	}
}

//Require gamestate upon entrance and check entrance with player
function enterGate(level)
{
	if(gamestate < level)
	{
		mWin("You may not enter this gate at this time.");
		mWin("Please come back later.");
		pause();
		push(2);
		end();
	}
	if(juirr < 2)
	{
		mWin("It is too big of a risk to send you in with your juirr level so low.");
		mWin("Please refill before you return.");
		pause();
		push(2);
		end();
	}
	mWin("Are you sure you want to enter this gate?");
	pause();
	mWin("Doing so will cause your juirr to drop by one.");
	pause();
	mWin("1: Proceed"); 
	mWin("2: Don't enter");
	input = mWinChoice(3);
	mWinCls();
	if(input == 0/* || input == "ENTER"*/)
	{
//		debugger("input good");
		juirr--;
	}
	else
	{
		push(2);
		end();
	}
}

//Cursor map in mWin
function mWinChoice(line)
{
	line--;
	cMap = createCursorMap();
	cursorMapAdd(40, 5 + (19*line), cMap);
	cursorMapAdd(40, 26 + (19*line), cMap);
	input = cursorMapRun(cMap);
	killCursorMap(cMap);
	return input;
}

//Custom cursor map in custom mWin; 2 options on lines 2 and 3
function cMWinChoice(one, two)
{
	cCMap = cCursorMap();
	cCMap->setFont("Teletype", 18);
	if(playery[0] < 5)
	{
		cCMap->addOption(one, 15, 45 + 348);
		cCMap->addOption(two, 15, 75 + 348);
	}
	else
	{
		cCMap->addOption(one, 15, 45);
		cCMap->addOption(two, 15, 75);
	}
	input = cCMap->runCursorMap();
	cCMap->release();
	kill(cCMap);
	return input;
}

function alert(string)
{
	setImageTransparent("alert.png", 180, 200, 279, 47, 255, 0, 255);
	colorRGB(255, 255, 255);
	font("Teletype");
	xpos = castInt(320 - (getTextWidth(string))/2);
	pixelText(xpos, 215, string);
	waitUpTo(.6);
//	delay(1);
//	pause();
}

//Custom mWin
function says(person, words)
{
	myMWin = cMWin(person);
	if(playery[0] < 5)
	{
		myMWin->shift("bottom");
	}
	myMWin->say(words);
	myMWin->release();
}

//Custom mWin
function sign(words)
{
	myMWin = cMWin("");
	if(playery[0] < 5)
	{
		myMWin->shift("bottom");
	}
	myMWin->winFont("Lucida Handwriting");
	myMWin->textColor(0, 0, 0);
	myMWin->background("cMWin_3.png");
	myMWin->say(words);
	myMWin->release();
}

//Pull up item selection menu
function itemSelect()
{
	saveScreen();
	font("Comic Sans MS");
	fontSize(20);
	bold(true);
	//Equipment slots
	equipSlot[0] = "283,64";
	equipSlot[1] = "374,64";
	equipSlot[2] = "466,64";
	equipSlot[3] = "551,64";
	
	//Item slots
	itemSlot[0] = "282,225";
	itemSlot[1] = "373,225";
	itemSlot[2] = "465,225";
	itemSlot[3] = "550,225";
	itemSlot[4] = "283,309";
	itemSlot[5] = "374,309";
	itemSlot[6] = "466,309";
	itemSlot[7] = "551,309";
	itemSlot[8] = "283,391";
	itemSlot[9] = "374,391";
	itemSlot[10] = "466,391";
	itemSlot[11] = "551,391";
	menu = createCanvas(640, 480);
	
	//Place menu background
	setImage("menuBack2.png", 0, 0, 640, 480, menu);
	//Menu template
	setImageTransparent("menu.png", 0, 0, 640, 480, 255, 0, 255, menu);
	
	//Juirr level
	getColor(r, g, b);
	colorRGB(44, 224, 48);
	if(juirr > 0)
	{
		fillRect(262, 148, 324, 172, menu);
	}
	if(juirr > 1)
	{
		fillRect(326, 148, 390, 172, menu);
	}
	if(juirr > 2)
	{
		fillRect(392, 148, 453, 172, menu);
	}
	colorRGB(r, g, b);
	
	//Place Equipment
	split(equipment, ",", gear);
	for(index = 0; index < 4; index++)
	{
		split(equipSlot[index], ",", coord);
		if(gear[index] ~= 0)
		{
			setImageTransparent(gear[index] + ".png", coord[0], coord[1], 32, 32, 255, 0, 255, menu);
		} 
		else
		{
			setImageTransparent("unknown.png", coord[0], coord[1], 32, 32, 255, 0, 255, menu);
		}
	}
	
	//Place Items
	for(index = 0; index < 13; index++)
	{
		split(itemSlot[index], ",", coord);
		if(item[index] ~= "")
		{
			setImageTransparent(item[index] + ".png", coord[0], coord[1], 32, 32, 255, 0, 255, menu);
		}
	}
	//Juirr label
	text(14.25, 7, "Juirr", menu);
	//Gold
	text(24.5, 8.5, "   Gold: " + gold, menu);
	//Player's name
	text(1.5, 19, name, menu);
	//Playing Time
	//text(1.5, 21, castInt(getTickCount()), menu);
	:chooseItem
	drawCanvas(menu, 0, 0);
		cCMap = cCursorMap();
		cCMap->setCursorProp("default", 40, 40);
		cCMap->addPoint(278, 221);
		cCMap->addPoint(369, 221);
		cCMap->addPoint(461, 221);
			cCMap->addPoint(546, 221);
			cCMap->addPoint(279, 305);
			cCMap->addPoint(370, 305);
			cCMap->addPoint(462, 305);
			cCMap->addPoint(547, 305);
			cCMap->addPoint(279, 387);
			cCMap->addPoint(370, 387);
			cCMap->addPoint(462, 387);
			cCMap->addPoint(547, 387);
			selection = cCMap->runCursorMap();
			cCMap->release();
			kill(cCMap);
			if(item[selection] ~= "")
			{
				cCMap = cCursorMap();
				cCMap->addOption("Use Item", 63, 110);
				cCMap->addOption("Cancel", 63, 230);
				choice = cCMap->runCursorMap();
				cCMap->release();
				kill(cCMap);
				restoreScreen();
				fontSize(18);
				if(choice == 0)
				{
//		debugger(item[selection] + "selected");
					return item[selection];
				}
				else
				{
					return 0;
				}
			}
			else
			{
				restoreScreen();
				return 0;
			}
}

class CCursorMap
{
private:

	//Cursor image
	var cursor;
	var width;
	var height;
	var transparency;

	//Point holders
	var point[];
	var option[];

	var fontSize;
	var font;

	var r;
	var g;
	var b;

public:

	//Default constructor
	function CCursorMap()
	{
		this->cursor = "bluePixel.png";
		this->width = 10;
		this->height = 50;
		this->transparency = 50;
		this->font = "Comic Sans MS";
		this->fontSize = 20;
		this->r = 255;
		this->g = 255;
		this->b = 255;
		index = 0;
		while(this->point[index] ~= "")
		{
			this->point[index] = "";
			index++;
		}
		index = 0;
		while(this->option[index] ~= "")
		{
			this->option[index] = "";
			index++;
		}
	}

	function setCursorProp(string, w, h)
	{
		if(string ~= "default")
		{
			this->cursor = string;
		}
		this->width = w;
		this->height = h;
	}

	//Add a cursor point
	function addPoint(x, y)
	{
		index = 0;
		while(this->point[index] ~= "")
		{
			index++;
		}
		this->point[index] = x + "," + y;
		kill(index);
	}

	//Add a cursor point with text
	function addOption(string, x, y);
	{
		index = 0;
		while(this->option[index] ~= "")
		{
			index++;
		}
		this->option[index] = string + "," + x + "," + y;
		kill(index);
	}	

	function setFont(style, size)
	{
		this->font = style;
		this->fontSize = size;
	}

	function textColor(red, green, blue)
	{
		this->r = red;
		this->g = green;
		this->b = blue;
	}

	//Run selection between points
	function runCursorMap()
	{
		clearbuffer();
		index = 0;
		//Put options (if applicable)
		if(point[0] == "")
		{
			colorRGB(this->r, this->g, this->b);
			font(this->font);
			fontSize(this->fontSize);
			bold(1);
			while(option[index] ~= "")
			{
				split(this->option[index], ",", coord[]);
				pixelText(coord[1], coord[2], coord[0]);
				index++;
			}
		}
		screen = createCanvas(640, 480);
		canvasGetScreen(screen);
		canv = createCanvas(640, 480);
		drawCanvas(screen, 0, 0, 640, 480, canv);
		index = 0;
//debugger(keypress);
		//Word Accompaniment
		if(this->point[0] == "");
		{
//debugger("Option mode.");

			while(keypress ~= "ENTER")
			{
				split(this->option[index], ",", coord[]);
				this->width = getTextWidth(coord[0]);
				this->height = getTextHeight(coord[0]);
//				pixelText(coord[1], coord[2], coord[0], canv);
				setImageAdditive(this->cursor, coord[1] - 2, coord[2], this->width + 4, this->height, this->transparency, canv);
				keypress = get();
				if(keypress == "RIGHT" || keypress == "DOWN");
				{
					if(this->option[index + 1] == "")
					{
						index = 0;
					}
					else
					{
						index++;
					}
				}
				elseif(keypress == "LEFT" || keypress == "UP");
				{
					if(this->option[index - 1] == "")
					{
						while(this->option[index] ~= "")
						{
							index++;
						}
						index--;
					}
					else
					{
						index--;
					}
				}
				elseif(keypress == "ENTER")
				{
					killCanvas(screen);
					killCanvas(canv);
					return index;
				}
				drawCanvas(canv, 0, 0);
				drawCanvas(screen, 0, 0, 640, 480, canv);
			}
		}

		//Just points
		else
		{
//debugger("Just point mode.");
		while(keypress ~= "ENTER")
		{
			split(this->point[index], ",", coord[]);
			setImageAdditive(this->cursor, coord[0], coord[1], this->width, this->height, this->transparency, canv);
			keypress = get();
			if(keypress == "RIGHT" || keypress == "DOWN");
			{
				if(this->point[index + 1] == "")
				{
					index = 0;
				}
				else
				{
					index++;
				}
			}
			elseif(keypress == "LEFT" || keypress == "UP");
			{
				if(this->point[index - 1] == "")
				{
					while(this->point[index] ~= "")
					{
						index++;
					}
					index--;
				}
				else
				{
					index--;
				}
			}
			elseif(keypress == "ENTER")
			{
				killCanvas(screen);
				killCanvas(canv);
				return index;
			}
			drawCanvas(canv, 0, 0);
			drawCanvas(screen, 0, 0, 640, 480, canv);
		}
		}
		kill(keypress);
	}
}

class cMWin
{
private:

	var speaker;
	var level;
	var font;
	var background;
	var textColor;

public:

	var noPause;

	function cMWin(string)
	{
		this->speaker = string;
		this->level = "top";
		this->font = "teletype"; //was teletype
		this->background = "cMWin_1.png";
		this->textColor = "255,255,255";
		this->noPause = 0;
	}

	function background(string)
	{
		this->background = string;
	}
	
	function winFont(string)
	{
		this->font = string;
	}
	
	function textColor(r, g, b)
	{
		this->textColor = r + "," + g + "," + b;
	}

	//Top or bottom?
	function shift(vertical)
	{
		this->level = vertical;
	}

	function say(str)
	{
		string = str;
		if(this->level == "bottom")
		{
			yshift = 348;
		}
		elseif(this->level == "top")
		{
			yshift = 0;
		}
		split(textColor, ",", addit[]);
		colorRGB(addit[0], addit[1], addit[2]);
		fontsize(18);
		font(this->font);
		screen = createCanvas(640, 480);
		canvasGetScreen(screen);
		canv = createCanvas(640, 480);
		drawCanvas(screen, 0, 0, 640, 480, canv);
		while(len(string) ~= 0)
		{
			initlnnum = 1;
			setImageTransparent(this->background, 0, 0 + yshift, 638, 128, 255, 0, 255, canv);
			if(this->speaker ~= "")
			{
				pixelText(15, 15 + yshift, this->speaker + ":", canv);
			}
			else
			{
				initlnnum = 0;
			}
			height = getTextHeight("Some name or other:");
			for(lnnum = initlnnum; lnnum <= 2; lnnum++)
			{
				split(string, " ", word[]);
				for(index = 0; length < 610; index++)
				{
					line += word[index] + " ";
					length = getTextWidth(line);
					if(length > 610)
					{
						line = left(line, len(line)- 1);
						length = getTextWidth(line);
						if(length > 610)
						{
							line = left(line, len(line) - len(word[index]));
						}
					}
					if(word[index + 1] == "")
					{
						length = 1000;
					}
				}
				pixelText(15, (lnnum*(height + 10)) + 15 + yshift, line, canv);
				string = right(string, len(string) - len(line));
				if(left(string, 1) == " ")
				{
					string = right(string, len(string) - 1);
				}
				if(string == "")
				{
					lnnum = 5;
				}
				kill(line);
				kill(length);
				for(sec = 0; sec < 20; sec++)
				{
					kill(word[sec]);
				}
			}
			if(this->noPause == 0)
			{
				drawCanvas(canv, 0, 0);
				pause();
				delay(.1);
			}
			else
			{
//				clear(cnvRenderNow);
				drawCanvas(canv, 0, 0/*, 640, 480, cnvRenderNow*/);
/*				renderNow(1);
				debugger("rendering");*/
				delay(this->noPause);
			}
		}
//		drawCanvas(screen, 0, 0);
		killCanvas(screen);
		killCanvas(canv);
	}
}	




