autolocal(1);

noTile[0] = "custom3.tst38";
noTile[1] = "custom.tst51";
noTile[2] = "custom.tst27";

//Require certain gear
split(equipment, ",", gear);
if(gear[0] == 0)
{
	end();
}

//The following settings may be relocated to individual level start programs if they are to change every level
pixelCoordinates(0); //Toggle pixel coordinates configuration, not to be confused with pixel movement.
global(blank) = "custom.tst52"; //Change, blank tile
global(rockInWater) = "custom.tst47"; //Change, sunken rock
global(water) = "default.tst2"; //Change, water tile
global(platform) = "custom.tst49"; // Change, platform image
global(block) = "default.tst3";

itemlocation("source", x, y, l);
switch(playerDirection(playerHandle[0]))
{
	case 7:
	{
		customPushItem(x, y, l, x, y - space, l, "NORTH");
	}
	case 3:
	{
		customPushItem(x, y, l, x, y + space, l, "SOUTH");
	}
	case 1:
	{
		customPushItem(x, y, l, x + space, y, l, "EAST");
	}
	case 5:
	{
		customPushItem(x, y, l, x - space, y, l, "WEST");
	}
	default
	{
	}
}
kill(blank);
kill(rockInWater);
kill(water);
kill(platform);
kill(space);
kill(block);

//---------------------Now for the functions

function customPushItem(ix, iy, il, dx, dy, dl, dir);
{
debug(0);
	switch(getBoardTile(ix, iy - space, il + 2))
	{
		case platform:
		{
			dTile = getBoardTile(dx, dy, dl);
			if(dTile ~= "" && dTile ~= noTile[0] && dTile ~= noTile[1] && dTile ~= noTile[2] && dTile ~= water)
			{
				//Get item sitting in the way of source item
				itemTwo = itemExists(dx, dy, dl);
				//Either no item is there or item is erased due to sinking
				if(itemTwo == -1 || dTile == rockInWater)
				{
			if(itemExists(ix, iy - 1, il + 2) == -1)
			{
					//Get vectors of initial location and destination
					iVector = vectorExists(ix, iy - space, il + 2);
					dVector = vectorExists(dx, dy - space, dl + 2);
					//Temporarily void destination vector
					nullVector(dVector);
					//Put blank image at initial location
					layerPut(ix, iy - space, il + 2, "");
					//If the item has been erased, now destroy it
					if(itemTwo ~= -1)
					{
						destroyItem(itemTwo)
					}
					//Get item handle
					item = itemExists(ix, iy, il);
					if(item ~= -1)
					{
						//Push item
					//	playerSpeed(playerHandle[0], .2);
					//	multirun()
					//	{
					//		itemPath(item, 0, dx, dy);
					//		playerPath(playerHandle[0], 0, ix, iy);
							pushItem(item, dir);
					//		push(dir);
					//	}
						blockOffButton(ix, iy, il);
					}
					//Flicker platform. Platform blinks anyway so this plays off of that
					layerPut(dx, dy - space, dl + 2, platform);
					delay(.05);
					layerPut(dx, dy - space, dl + 2, blank);
					delay(.04);
					layerPut(dx, dy - space, dl + 2, platform);
					delay(.025);
					layerPut(dx, dy - space, dl + 2, blank);
					delay(.02);
					layerPut(dx, dy - space, dl + 2, platform);
					//Reinstate previously nulled vector
					solidifyVector(iVector);
			}
			else
			{
				0helpful.says("", "You're not that strong!");
			}
				}
			}
			default:
			{
//				debugger("Not Working");
			}
		}
		default:
		{
			dTile = getBoardTile(dx, dy, dl);
//debugger(dTile);
			//Sink rock if needs be
			if(sinkRock(dx, dy, dl, ix, iy, il, dir) == 1)
			{
			}
			//If destination tile allows movement
			elseif(dTile ~= "" && dTile ~= noTile[0] && dTile ~= noTile[1] && dTile ~= noTile[2])
			{
				//Get item sitting in the way of source item
				itemTwo = itemExists(dx, dy, dl);
				//Either no item is there or item is erased due to sinking
				if(itemTwo == -1 || dTile == rockInWater)
				{
					//If the item has been erased, now destroy it
					if(itemTwo ~= -1)
					{
						destroyItem(itemTwo)
					}
					//Get item handle
					item = itemExists(ix, iy, il);
					if(item ~= -1)
					{
//						playerSpeed(playerHandle[0], .5);
//	putPlayer(playerHandle[0], playerx[0], playery[0], playerlayer[0] - 1);
						//Push item
//						multirun()
//						{
//							itemPath(item, 0, dx, dy);
//							playerPath(playerHandle[0], 0, ix, iy);
							pushItem(item, dir);
					//		push(dir);
//						}
//	putPlayer(playerHandle[0], playerx[0], playery[0], playerlayer[0] + 1);
//						playerSpeed(playerHandle[0], .05);
						blockOffButton(ix, iy, il);
					}
				}
			}
			//Check if block is on a button, execute button
			//blockOnButton(item);
		}
		blockOnButton(item);
	}
debug(1);
}

//If block is on button, destroy corresponding obstruction	
function blockOnButton(item)
{
//	debugger("Running blockOnButton()");
	setResumeNextHandler();
	//Get item handle
	itemLocation(item, x, y, l);
	//Get tile item just pushed to; if buttonTile is not set, will not trigger
	if(/*getBoardTile(x, y, l) == buttonTile && */getBoardTile(x, y, l) ~= "")
	{
		for(index = 0; index < buttons; index++)
		{
			split(button[index], ",", attr[]);
			if(attr[1] == x && attr[2] == y && attr[3] == l)
			{
//	debugger("button " + index + " found");
				//Remove obstruction
				if(attr[0] == 0)
				{
					//debugger("Type 0 button");
					//Get information from variable
					//Delete vector associated with obstruction
					vector = vectorExists(attr[4], attr[5], attr[6]);
					nullVector(vector);
					//Replace obstruction image with blank tile.
					layerPut(attr[4], attr[5], attr[6], blank);
					//Play sound effect
					wav("hit.wav");
				}
				//Place platform on single item upon button
				elseif(attr[0] == 1)
				{
					//debugger("Type 1 button");
					layerPut(x, y - 1, l + 2, platform);
				}
				//Place platform on every item
				elseif(attr[0] == 2)
				{
					secindex = 4;
					while(attr[secindex] ~= "")
					{
						itemLocation(attr[secindex], itemx, itemy, iteml);
						layerPut(itemx, itemy - 1, iteml + 2, platform);
						secindex++;
					}
				}
				elseif(attr[0] == 3)
				{
					code = attr[4];
					codindex = 5
					while(attr[codindex] ~= "")
					{
						code += ("," + attr[codindex]);
						codindex++;
					}
//debugger(code);
					RPGCode(code);
				}
			}
		}
	}
}

function blockOffButton(ix, iy, il)
{
	if(/*getBoardTile(ix, iy, il) == buttonTile && */getBoardTile(ix, iy, il) ~= "")
	{
		for(index = 0; index < buttons; index++)
		{
			split(button[index], ",", attr[]);
			if(attr[1] == ix && attr[2] == iy && attr[3] == il)
			{
				if(attr[0] == 0)
				{
					vector = vectorExists(attr[4], attr[5], attr[6]);
					solidifyVector(vector);
					if(attr[7] ~= 1)
					{
						layerPut(attr[4], attr[5], attr[6], block);
					}
					else
					{
						layerPut(attr[4], attr[5], attr[6], "default.tst81");
					}
				}
			}
		}
	}
}

//Sink rock
function sinkRock(dx, dy, dl, ix, iy, il, dir);
{
	dTile = getBoardTile(dx, dy, dl);
	//If water tile and board allows sunken rocks
	if(/*sinks ~= 0 && */dTile == water)
	{
//		debugger("water detected");
		dVector = vectorExists(dx, dy, dl);
//		debugger("Vector: " + dVector);
		nullVector(dVector);
//		debugger("Vector should be gone");
		item = itemExists(ix, iy, il);
		if(item ~= -1)
		{
			//Push item
			pushItem(item, dir);
//			debugger("Item should be pushed");
		}
		//Erase item
		eraseItem(item);
		//Put sunken rock image.
		layerPut(dx, dy, dl, rockInWater);
		//You could insert a splash wav here
		//wav("splash.wav");
		return 1;
	}
	return 0;
}

//Toggle pixel coordinates calibration
function pixelCoordinates(bool)
{
	if(bool == 1)
	{
		global(space) = 32;
	}
	elseif(bool == 0)
	{
		global(space) = 1;
	}
}

//Check for item's existence, based on location, returns handle else -1
function itemExists(x, y, l);
{
	debug(0);
	for(index = 0; index < 100; index++)
	{
		itemlocation(index, ix, iy, il);
		setResumeNextHandler();
		if(ix == x && iy == y && il == l)
		{
			debug(1);
			return index;
		}
		setResumeNextHandler();
	}
	return -1
}


//Null a solid vector
function nullVector(vector)
{
	boardGetVector(castNum(vector), type, pointCount, layer, isClosed, attributes);
	boardSetVector(castNum(vector), tkVT_WAYPOINT, pointCount, layer, isClosed, attributes);
}

//Solidify a nulled vector
function solidifyVector(vector)
{
	boardGetVector(castNum(vector), type, pointCount, layer, isClosed, attributes);
	boardSetVector(castNum(vector), tkVT_SOLID, pointCount, layer, isClosed, attributes);
}

//Find a vector at a given set of coordinates and return its handle
//This is complicated so I am not even going to attempt to annotate or explain it
function vectorExists(x, y, l)
{
	leftx = ((32 * x) - 32);
	rightx = (32 * x);
	topy = ((32 * y) - 32);
	bottomy = (32 * y);
	vectorCount = boardGetVector();
	for(index = 0; index < vectorCount; index++)
	{
		boardGetVector(index, type, pointCount, layer, isClosed, attributes);
		if(pointCount == 4 && layer == l)
		{
			boardGetVectorPoint(index, 0, x[0], y[0])
			boardGetVectorPoint(index, 1, x[1], y[1])
			boardGetVectorPoint(index, 2, x[2], y[2])
			boardGetVectorPoint(index, 3, x[3], y[3])
			if(x[0] == x[1])
			{
				if(x[0] == leftx || x[0] == rightx)
				{
					if(x[2] == leftx || x[2] == rightx)
					{
						branch(:branch);
					}
				}
			}
			elseif(x[0] == x[2])
			{
				if(x[0] == leftx || x[0] == rightx)
				{
					if(x[3] == leftx || x[3] == rightx)
					{
						branch(:branch);
					}
				}
			}
			elseif(x[0] == x[3])
			{
				if(x[0] == leftx || x[0] == rightx)
				{
					if(x[1] == leftx || x[1] == rightx)
					{
						branch(:branch);
					}
				}
			}
			if(proceed == 1)
			{
:branch
				if(y[0] == y[1])
				{
					if(y[0] == topy || y[0] == bottomy)
					{
						if(y[2] == topy || y[2] == bottomy)
						{
							return index;
						}
					}
				}
				elseif(y[0] == y[2])
				{
					if(y[0] == topy || y[0] == bottomy)
					{
						if(y[3] == topy || y[3] == bottomy)
						{
							return index;
						}
					}
				}
				elseif(y[0] == y[3])
				{
					if(y[0] == topy || y[0] == bottomy)
					{
						if(y[1] == topy || y[1] == bottomy)
						{
							return index;
						}
					}
				}
			}
		}
	}
//	debugger("Vector not found");
	return -1;
}



